""" LDIF output file stuff """

from ldif import LDIFWriter

from mylib.pbar import Pbar


def generate_ldif_entries_output(options, entries, attributes_names):
    """ Generate an LDIF output file """

    pbar = Pbar(
        f'Export result to "{options.output}"',
        len(entries),
        enabled=options.progress)
    with open(options.output, 'w', encoding=options.output_encoding) as file_descriptor:
        output = LDIFWriter(file_descriptor, base64_attrs=['userPassword'])
        for entry_dn, attrs in entries.items():
            output.unparse(
                entry_dn,
                dict(
                    (attr, [value.encode(options.output_encoding) for value in values])
                    for attr, values in attrs.items()
                    if attr in attributes_names
                )
            )
            pbar.increment()
        pbar.finish()
